#include <stdio.h>
#include <string.h>
#include <io.h>
#include <fcntl.h>
#include <ctype.h>
#include <dos.h>
#include <fidolib.h>
#ifdef __TURBOC__
#include <dir.h>
#else
#include <direct.h>
#endif

#define ECHOCHARS "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789" \
                  ".!$/\'-_&:?"

#define CONFNAME   "doavail.cfg"

FILE * fin,* fout;
char str[1024];
char netmail[256];
char myname[80];
struct message msghdr;
unsigned mynet,mynode;
unsigned nodes;
unsigned _dos_r;

struct
{ uword net,node;
  enum {FECHO, GECHO, SQUISH} tosser;
  char out[256];
} node[16];

void do_squish(char * in,char * out)
{ char *p, *p1;
  int  prev;

  fin=fopen(in,"r");
  if (fin==NULL) return;
  fout=fopen(out,"w");
  if (fout==NULL)
  { printf("Can't open %s\n",out);
    return;
  }
  prev=0;
  while (fgets(str,sizeof(str),fin))
  {
    if (str[0]=='\n')
      continue;
    if (strncmp(str, "List of existing areas", 22)==0)
      continue;
    if (strncmp(str, "---", 3)==0)
      continue;
    if (strncmp(str, "( continued from the previous message )", 39)==0)
      continue;
    if (strncmp(str, "( continued in the next message )", 33)==0)
      continue;
    if (strncmp(str, " * Origin:", 10)==0)
      continue;
    if (strchr(ECHOCHARS, str[0]))
    {
      if (prev)
      { fputs("\n", fout);
        prev=0;
      }
      for (p=str; strchr(ECHOCHARS, *p); p++);
      if (*p++!=' ') continue;
      p1=p;
      if (*p++!='.') continue;
      while (*p++=='.');
      if (*p++!=' ') continue;
      p=strchr(p, '\"');
      if (p==NULL) continue;
      strcpy(p1, p+1);
    }
    else
    { if (prev==0) continue;
      if (strncmp(str, "                    ", 20))
        continue;
      for (p=str+20; *p==' '; p++);
      p1=str+1;
      strcpy(p1, p);
    }
    p=strchr(p1, '\"');
    if (p)
    { strcpy(p, "\n");
      prev=0;
    }
    else
    { p=strchr(p1, '\n');
      if (p) *p='\0';
      prev=1;
    }
    fputs(str, fout);
  }
  if (prev) fputs("\n", fout);
  fclose(fin);
  fclose(fout);
  unlink(in);
}

void do_fecho(char * in,char * out)
{ char * p;
  int  was_empty;

  fin=fopen(in,"r");
  if (fin==NULL) return;
  fout=fopen(out,"w");
  if (fout==NULL)
  { printf("Can't open %s\n",out);
    return;
  }
  was_empty=0;
  while (fgets(str,sizeof(str),fin))
  {
    p=strchr(str,'\n');
    if (p==NULL) continue;
    for (p--;(*p==' ') && (p>str);*p--=0);
    if (*p!=' ') p++;
    strcpy(p,"\n");
    if (strncmp(str,"Available areas for ",20)==0)
    { was_empty=0;
      continue;
    }
    if ((str[0]!='\n') && (str[0]!=' '))
    { if (was_empty==2)
      { was_empty=0;
        continue; /*  㯯  */
      }
      was_empty=0;
    }
    if (strcmp(str,"\n")==0)
    { was_empty++;
      continue;
    }
    else
      was_empty=0;
    if (strncmp(str,"[continued]",11)==0)
      continue;
    if (strncmp(str,"'*' - area active ",18)==0)
      continue;
    if (strncmp(str,"---",3)==0)
      continue;
    if (isdigit(*str))
    { for (p=str;isdigit(*p);p++);
      if (strncmp(p," areas available",16)==0)
        continue;
    }
    if ((str[0]==' ') && (str[1]==' ') && (str[2]!=' '))
      strcpy(str,str+2);
    else if ((str[0]=='*') && (str[1]==' ') && (str[2]!=' '))
      strcpy(str,str+2);
    if (strncmp(str,"                                        ",40)==0)
    { fseek(fout,-2,SEEK_CUR);
      fputs(str+39,fout);
      continue;
    }
    for (p=str;isspace(*p);p++);
    if (*p=='.') continue;
    for (p=str;(!isspace(*p)) && *p;p++)
      if (strchr(ECHOCHARS, *p)==0)
        break;
    if (*p && !isspace(*p))
      continue;
    p=strchr(str,' ');
    if (p)
    { p++;
      while (*p=='.') strcpy(p,p+1);
      if (*p==' ') strcpy(p,p+1);
      if (strncmp(p,". ",2)==0)
        strcpy(p,p+2);
    }
    fputs(str,fout);
  }
  fclose(fin);
  fclose(fout);
  unlink(in);
}

void do_gecho(char * in,char * out)
{ char * p, * p1;

  fin=fopen(in,"r");
  if (fin==NULL) return;
  fout=fopen(out,"w");
  if (fout==NULL)
  { printf("Can't open %s\n",out);
    return;
  }
  while (fgets(str,sizeof(str),fin))
  {
    if (strcmp(str,"\n")==0)
      continue;
    if ((str[0]!=' ') && (str[0]!='+') && (str[0]!='-'))
      continue;
    if ((str[0]=='-') && (str[1]=='-'))
      continue;
    if ((str[0]==' ') && (str[1]=='\''))
      continue;
    strcpy(str,str+1);
    if ((str[0]==' ') || (str[0]=='\n'))
      continue; /*  直 砩 */
    p=strpbrk(str," \t");
    if (p)
    { *p++=' ';
      for (p1=p;(*p1==' ')||(*p1=='\t');p1++);
      strcpy(p,p1);
    }
    fputs(str,fout);
  }
  fclose(fin);
  fclose(fout);
  unlink(in);
}

void scan_nmail(void)
{ struct ffblk ff;
  int h,r,i;
  char toout,c;

  strcpy(str,netmail);
  strcat(str,"*.msg");
  for (r=findfirst(str,&ff,0);r==0;r=findnext(&ff))
  { strcpy(str,netmail);
    strcat(str,ff.ff_name);
    h=open(str,O_BINARY|O_RDWR|O_DENYALL);
    if (h==-1)
      continue;
    if (read(h,&msghdr,sizeof(msghdr))!=sizeof(msghdr))
    {
   nextmsg:
      close(h);
      continue;
    }
    if (msghdr.attr & (msgLOCAL | msgFILEATT | msgFREQ | msgORPHAN))
      goto nextmsg;
    if ((msghdr.dest_net!=mynet) || (msghdr.dest_node!=mynode))
      goto nextmsg;
    for (i=0;i<nodes;i++)
      if ((msghdr.orig_net==node[i].net) &&
          (msghdr.orig_node==node[i].node))
        break;
    if (i==nodes)
      goto nextmsg;
    if (stricmp(msghdr.to, myname))
      goto nextmsg;
    if (stricmp(msghdr.from, "areafix") &&
        stricmp(msghdr.from, "gecho")   &&
        stricmp(msghdr.from, "sqafix"))
          goto nextmsg;
    if (strnicmp(msghdr.subj,"List of areas available ",24))
      if (strnicmp(msghdr.subj,"List of available areas ",24))
        if (strnicmp(msghdr.subj,"List request",12))
          goto nextmsg;
    /*  */
    /*  ⮢, 㤦  . 䨣 */
    if (access(node[i].out,0))
      fout=fopen(node[i].out,"w");
    else
      fout=fopen(node[i].out,"a");
    for (;;)
    { if (read(h,&c,1)!=1)
        break;
      if (c=='\x1')
        toout=0;
      else
        toout=1;
      for (;;)
      { if (c=='\r')
        { if (toout) fputc('\n',fout);
          break;
        }
        if (c==0)
          break;
        if (toout)
          fputc(c,fout);
        if (read(h,&c,1)!=1)
        { c=0;
          break;
        }
      }
      if (c==0)
        break;
    }
    fclose(fout);
    close(h);
    unlink(str);
  }
}

int config(void)
{ char * p;
  char tosser[80];

  fin=fopen(CONFNAME,"r");
  if (fin==NULL)
  { printf("Can't open %s!\n", CONFNAME);
    return 1;
  }
  nodes=0;
  while (fgets(str,sizeof(str),fin))
  { p=strchr(str,'\n');
    if (p) *p=0;
    p=strchr(str,';');
    if (p) *p=0;
    if ((str[0]=='\0') || (str[0]=='#')) continue;
    if (strnicmp(str,"netmail=",8)==0)
    { strcpy(netmail,str+8);
      if (netmail[strlen(netmail)-1]!='\\')
        strcat(netmail,"\\");
      continue;
    }
    if (strnicmp(str,"sysop=",6)==0)
    { strcpy(myname,str+6);
      continue;
    }
    if (strnicmp(str,"address=",8)==0)
    { if (sscanf(str+8,"%u/%u",&mynet,&mynode)!=2)
      { printf("You must specify 2d-address!\n");
        fclose(fin);
        return 2;
      }
      continue;
    }
    if (strnicmp(str,"node=",5)==0)
    { if (sscanf(str+5,"%u/%u %s %s",&node[nodes].net, &node[nodes].node,
          &node[nodes].out, tosser)!=4)
      { puts("Incorrect Node line:");
        puts(str);
        fclose(fin);
        return 2;
      }
      if (stricmp(tosser,"fastecho")==0)
        node[nodes].tosser=FECHO;
      else if (stricmp(tosser,"gecho")==0)
        node[nodes].tosser=GECHO;
      else if (stricmp(tosser,"squish")==0)
        node[nodes].tosser=SQUISH;
      else
      { printf("Unknown tosser %s!\n", tosser);
        fclose(fin);
        return 3;
      }
      nodes++;
      continue;
    }
    puts("Incorrect line in config ignored:");
    puts(str);
  }
  return 0;
}

int main(int argc,char ** argv)
{ unsigned i;
  char * p;
  char tmpname[256];

  strcpy(str,argv[0]);
  p=strrchr(str,'\\');
  if (p)
  { *p=0;
    setdisk(toupper(str[0])-'A');
    chdir(str);
  }

  if (config())
    return 1;
  scan_nmail();
  for (i=0;i<nodes;i++)
  { if (access(node[i].out,0))
      continue;
    strcpy(tmpname,node[i].out);
    p=strrchr(tmpname,'\\');
    if (p==NULL) p=tmpname;
    p=strchr(tmpname,'.');
    if (p==NULL) p=tmpname+strlen(tmpname);
    strcpy(p,".$$$");
    rename(node[i].out,tmpname);
    if (node[i].tosser==GECHO)
      do_gecho(tmpname,node[i].out);
    else if (node[i].tosser==SQUISH)
      do_squish(tmpname,node[i].out);
    else
      do_fecho(tmpname,node[i].out);
  }
  return 0;
}
